<?

/* 
   Slide show written by Kyoorius 8/2/00
   Use and modify if u like.
   kyoorius@techfreakz.org


Requirements:  	PHP with GD and jpeg support. 
		See http://www.php.net:8000/manual/en/html/ref.image.html
		if you don't have it built in.


Usage: 

Drop this script into a web acessible directory with lots of pics.
chmod a+w the directory, then fetch the script using your web browser.
The first time the script is run, it will create a ./thumbs directory,
build all the thumbnails, and place them into this directory.

A "descriptions" file will also be created. Modify this file to change
the order of your pics, or to add comments.

Example of descriptions file:
title=DEFCON 9 (aka Hax0rpalooza)<br>Blablablabal, Title goes here
upurl=http://www.blalbla.com/com (takes you to another url which you specify)
P1010002.jpg,Some people standing around
P1010006.JPG,more people standing around
P1010007a.jpg,blabla picture description
...

  
The thumbnails may take a while to build depending on the number/size
of pics and the speed/power of your server. 

After it's all done, you may want to "chmod 755 <webdirectory> -R" to secure
things up.

If you add new pics, you can add the filenames to the "descriptions" or 
delete the "descriptions" file to rebuild everything in the directory from 
scratch.


*/


$title="";
$maxx=100; $maxy=100;
set_time_limit(0); # kill the 30 second timeout


function createthumbnail ($x,$y,$i,$dest) {
if ($x) {$maxx=$x;} else {$maxx=50;}
if ($y) {$maxy=$y;} else {$maxy=50;}
$tmp=strtoupper($i);
if (eregi(".JPG",$i)) {
        $im=@ImageCreateFromJPEG($i);
}
if (eregi(".GIF",$i) || eregi(".PNG",$i)) {
        $im=@ImageCreateFromPNG($i);
}

$x=imagesx($im);
$y=imagesy($im);
if ($dest=="smjpg") {
	$r=$x/$y;
	$ix=0;$iy=0;
	if (($maxx/$maxy)<($r)) { $tx=$maxx; $ty=$maxx/$r;} 
	else {$ty=$maxy; $tx=$maxy*$r;}
	$im2 = imagecreate ($tx,$ty);
}
else {
	$im2 = imagecreate($maxx,$maxy);
	$bg = ImageColorAllocate ($im2, 255,255,255);
	imagefilledrectangle ($im2,0,0,$maxx,$maxy,$bg);

	if ($x>$y) {$tx=$maxx; $ty=$y/$x*$maxx; $iy=($maxy-$ty)/2; $ix=0;}
	else {$ty=$maxy; $tx=$x/$y*$maxy; $ix=($maxx-$tx)/2;$iy=0;}
}



imagecopyresized($im2,$im,$ix,$iy,0,0,$tx,$ty,$x,$y);
if ($dest=="smjpg") {
	header ("Content-type: image/jpeg");
	imagejpeg($im2,"",75);
	#header ("Content-type: image/gif");
        #imagepng($im2);
}
elseif ($dest) { 
	imagepng($im2,$dest); 
	chmod ($dest,0777);
}
else {
	header ("Content-type: image/gif");
	imagepng($im2);
}
}


function displaythumbnails ($data) {
global $maxx,$maxy,$size,$tnmode;

$x=0;
if (!file_exists("thumbs")) {
	mkdir("thumbs",0777);
}     
foreach ($data as $tmp) {
        $x++;
        list($file,$msg)=explode(",",$tmp);
        $file=chop($file);
        if (!file_exists("./thumbs/$file")) {
                createthumbnail($maxx,$maxy,$file,"./thumbs/$file");
        }
        print "<a href=\"./?slide=$x&size=$size";
	if (isset($tnmode)) {print "&tnmode=";}
	print "\">";
	if (file_exists("./thumbs/$file")) {
		print "<img src=\"./thumbs/".rawurlencode($file)."\"";
	} 
	else {
		print "<img src=\"?tn=".rawurlencode($file)."\"";
	}
	print " width=$maxx height=$maxy border=0></a>&nbsp;\n";
}
}


function displaythumbnailsinline ($data) {
global $maxx,$maxy,$size,$upurl;

$x=0;
if (!file_exists("thumbs")) {
        mkdir("thumbs",0777);
}
?><a href="?tnmode=" target="photo">Thumbnails</a> <?
if ($upurl) {print "<a href=\"$upurl\" target=\"_parent\">Up</a>";}
foreach ($data as $tmp) {
        $x++;
        list($file,$msg)=explode(",",$tmp);
        $file=chop($file);
        if (!file_exists("./thumbs/$file")) {
                createthumbnail($maxx,$maxy,$file,"./thumbs/$file");
        }
        print "<a href=\"./?slide=$x&size=$size&tnmode=\" target=\"photo\">";
        if (file_exists("./thumbs/$file")) {
                print "<img src=\"./thumbs/".rawurlencode($file)."\"";
        }
        else {
                print "<img src=\"?tn=".rawurlencode($file)."\"";
        }
        print " width=$maxx height=$maxy border=0></a><BR>\n";
}
print "<a href=\"?\" target=\"_parent\">No Index</a>";
}

error_reporting(1);  # supress warnings about not being able to create "descriptions" file

if ($tn) {createthumbnail($maxx,$maxy,$tn); exit;}
if ($smpic) {createthumbnail(300,300,$smpic,"smjpg"); exit;}
if (!$slide) {$thumbnails=1;}
$data=array();

if (file_exists("descriptions")) {
        $data=file("descriptions");
	if (strtoupper(substr($data[0],0,6)) == "TITLE=") { 
		$title=substr($data[0],6);
		$trash=array_shift($data);
	}
	if (strtoupper(substr($data[0],0,6)) == "UPURL=") {
                $upurl=substr($data[0],6);
                $trash=array_shift($data);
        }
}
else {
        $handle=opendir('.');
        while (false!==($file = readdir($handle))) {
                if ($file != "." && $file != ".." && (eregi(".gif",$file) || eregi(".jpg",$file))) {
                array_push($data,$file);
                }
        }
        closedir($handle);

# try and create the description file
        $fp=fopen("descriptions","w");
        if ($fp) {
		fputs($fp,"title=\n");
		fputs($fp,"upurl=\n");
                foreach ($data as $out) {
                        fputs($fp,"$out\n");
                }
        fclose($fp);
	chmod("descriptions",0777);
        }

}

if (isset($tni)) {displaythumbnailsinline($data); exit;}
if (isset($frames)) {?>
<HTML>
<HEAD> <TITLE></TITLE></HEAD>

<FRAMESET COLS="*,150" BORDER=1>
  <FRAME SRC="?tnmode=" NAME="photo" frameborder="no">
  <FRAME SRC="index.php?tni=" NAME="index"  frameborder="no">

  <NOFRAMES>You must use a browser that can display frames
  to see this page. </NOFRAMES>
</FRAMESET>
</HTML>
<?
exit;
}


?>

<head>
   <title><?=$title?></title>
</head>
<body bgcolor="#FFFFFF" alink="#FF0000" vlink="#000000" link="#000000">
<center>
<b><?=$title?></b><p>
<?

if ($thumbnails) {
?>
<table width=600>
<tr><td width=600><?displaythumbnails($data);?></td></tr>
</table>
<font size=-2 face="arial,helvetica" color="lightgrey">Thumbprintz  v1.3 &nbsp; &copy; 2001 Kyoorius @ techfreakz.org All Rights Reserved</font>
<?
}
else {

$max=count($data);
if ($slide < 1 || $slide > $max) {$slide=1;}
$prev=$slide-1; $next=$slide+1;
$file=substr($data[$slide-1],0,strcspn($data[$slide-1],','));
$msg=substr($data[$slide-1],strcspn($data[$slide-1],',')+1);
$file=chop($file);
if (!isset($tnmode)) {
?>
<font face="arial" size=-2>
<?

if ($slide>1) {print "<a href=\"?slide=$prev&size=$size\">&lt;-PREVIOUS</a> &nbsp;&nbsp;";}
?> <a href="./?size=<?=$size?>">(TN)</a> <?
for($x=1;$x<($max+1);$x++) {
        if ($x==$slide) {print "<font color=RED><b>$x</b></font> ";}
        else {print "<a href=\"?slide=$x\">$x</a> ";}
}
?> <a href="./">(TN)</a> <?
if ($slide<$max) {print "&nbsp; &nbsp;<a href=\"?slide=$next&size=$size\">NEXT-></a>";}
print "<br>";
if ($size) { print "<a href=\"?slide=$slide&size=\">Bigger pics</a> "; }
else {print "<a href=\"?slide=$slide&size=sm\">Smaller pics</a> "; }
print "&nbsp;<a href=\"?frames=\" target=\"_parent\">Index</a>";
if ($upurl) {print " <a href=\"$upurl\">Up</a>";}

print "</FONT><P>";
}
?>
<table><tr>
<?
print "<td ALIGN=CENTER VALIGN=CENTER><a href=\"?slide=$next&size=$size";
if (isset($tnmode)) {print "&tnmode=";}
print "\"><img SRC=\"";
if ($size) { print "?smpic=";}
print rawurlencode($file);
print "\"></a></td>"; 

?>

</tr>
</table>
<? print "$msg<p>"; ?>
<font size=-2 face="arial,helvetica" color="lightgrey">Thumbprintz  v1.3 &nbsp; &copy; 2001 Kyoorius @ techfreakz.org  All Rights Reserved</font>
<? 
}


?>
</center>
</body>
</html>

